#
# INTEL CONFIDENTIAL
#
# Copyright 2013-2017 Intel Corporation All Rights Reserved.
#
# The source code contained or described herein and all documents related
# to the source code ("Material") are owned by Intel Corporation or its
# suppliers or licensors. Title to the Material remains with Intel Corporation
# or its suppliers and licensors. The Material contains trade secrets and
# proprietary and confidential information of Intel or its suppliers and
# licensors. The Material is protected by worldwide copyright and trade secret
# laws and treaty provisions. No part of the Material may be used, copied,
# reproduced, modified, published, uploaded, posted, transmitted, distributed,
# or disclosed in any way without Intel's prior express written permission.
#
# No license under any patent, copyright, trade secret or other intellectual
# property right is granted to or conferred upon you by disclosure or delivery
# of the Materials, either expressly, by implication, inducement, estoppel or
# otherwise. Any license under such intellectual property rights must be
# express and approved by Intel in writing.

import sys
import time
import glob

sys.path.append('/usr/share/chroma-manager')

from django.core.management import setup_environ
import settings
setup_environ(settings)

from chroma_core.lib.util import CommandLine
cl = CommandLine()
try_shell = cl.try_shell

from chroma_core.lib.service_config import ServiceConfig


def backup_certs_and_pems():
    try:
        ts = int(time.time())
        target_dir = "/var/lib/chroma/backup_{0}".format(ts)
        try_shell(['mkdir', target_dir])
        certs = glob.glob('/var/lib/chroma/*.crt')
        print "    - Backing up certificates and pem files to \
{0}".format(target_dir)
        try_shell(['cp'] + certs + [target_dir])
        pems = glob.glob('/var/lib/chroma/*.pem')
        try_shell(['cp'] + pems + [target_dir])
    except Exception as e:
        print 'Could not backup certificates in /var/lib/chroma'
        print e


def update_manager_file(remove_path, from_path, to_path):
    try:
        print '    - Updating {0} on manager node.'.format(to_path)
        try_shell([
            'rm',
            '-f',
            remove_path
        ])

        try_shell([
            'cp',
            from_path,
            to_path
        ])
    except Exception as e:
        print 'Could not replace {0} on the manager.'.format(to_path)
        print e


def update_manager_crypto():
    return update_manager_file(
        '/usr/share/chroma-manager/chroma_core/services/http_agent/crypto.pyc',
        'chroma_manager_crypto.py',
        '/usr/share/chroma-manager/chroma_core/services/http_agent/crypto.py'
    )


def update_agent_bootstrap():
    try_shell([
        'sed',
        '-ie',
        's/csr = launch_command("openssl req -new -subj \/C=\/ST=\/L=\/O=\/CN=%s \
-key %s" % (fqdn, PRIVATE_KEY))/csr = launch_command("openssl req -new -sha256 -subj \
\/C=\/ST=\/L=\/O=\/CN=%s -key %s" % (fqdn, PRIVATE_KEY))/g',
        '/usr/share/chroma-manager/agent-bootstrap-script.template'
    ])


def restart():
    print '\nRestarting Manager:'
    service_config = ServiceConfig()
    service_config.stop()
    service_config.start()
